-- Vhdl test bench created from schematic C:\YODA\VADER\VADERtest.sch - Wed May 16 23:54:32 2012
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY VADERtest_VADERtest_sch_tb IS
END VADERtest_VADERtest_sch_tb;
ARCHITECTURE behavioral OF VADERtest_VADERtest_sch_tb IS 

   COMPONENT VADERtest
   PORT( Clock	:	IN	BIT; 
          TestHash	:	IN	BIT_VECTOR (31 DOWNTO 0); 
          HashCorrectFlag	:	OUT	BIT; 
          Reset	:	IN	BIT; 
          Load	:	IN	BIT;
			 valid : OUT BIT;
			 hash : OUT BIT_VECTOR (31 DOWNTO 0);
          Message	:	IN	BIT_VECTOR (31 DOWNTO 0);
			 bit_prb        : out   integer range 7 downto 0; 
             correct_prb    : out   integer range 7 downto 0);
   END COMPONENT;

   SIGNAL Clock	:	BIT;
   SIGNAL TestHash	:	BIT_VECTOR (31 DOWNTO 0);
   SIGNAL HashCorrectFlag	:	BIT;
   SIGNAL Reset	:	BIT;
   SIGNAL Load	:	BIT;
	SIGNAL valid : BIT;
	SIGNAL hash : BIT_VECTOR (31 DOWNTO 0);
   SIGNAL Message	:	BIT_VECTOR (31 DOWNTO 0);
	SIGNAL bit_prb        :   integer range 7 downto 0; 
   SIGNAL correct_prb    :   integer range 7 downto 0;
	constant clk_period : time := 10 us;

BEGIN

   UUT: VADERtest PORT MAP(
		Clock => Clock, 
		TestHash => TestHash, 
		HashCorrectFlag => HashCorrectFlag, 
		Reset => Reset,
		hash => hash,
		bit_prb => bit_prb,
		correct_prb => correct_prb,
		valid => valid,
		Load => Load, 
		Message => Message
   );

-- *** Test Bench - User Defined Section ***
clk_process :process
   begin
		Clock <= '0';
		wait for clk_period/2;
		Clock <= '1';
		wait for clk_period/2;
   end process;

   tb : PROCESS
   BEGIN
		wait for 100 ns;
		Load<='0';
		Message<=X"00000000";
		Reset <= '1';
		wait for clk_period;
		Load<='1';
		Message<=X"61626364";
		Reset <= '0';
		wait for clk_period;
		Message<=X"65800000";
		wait for clk_period;
		Message<=X"00000000";
		wait for clk_period*13;
		Message<=X"00000028";
		wait for clk_period;
		Message<=X"00000000";
		Load<='0';
		wait for clk_period*66;
		wait for clk_period*0.5;
		TestHash<=X"03de6c57";
		wait for clk_period;
		TestHash<=X"0bfe24bf";
		wait for clk_period;
		TestHash<=X"c328ccd7";
		wait for clk_period;
		TestHash<=X"ca46b76e";
		wait for clk_period;
		TestHash<=X"adaf4334";
      WAIT; -- will wait forever
   END PROCESS;
	
	
-- *** End Test Bench - User Defined Section ***

END;
