--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   00:28:13 05/17/2012
-- Design Name:   
-- Module Name:   C:/YODA/VADER/VADERTester.vhd
-- Project Name:  VADER
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sha1
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY VADERTester IS
END VADERTester;
 
ARCHITECTURE behavior OF VADERTester IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT sha1
    PORT(
         m : IN  bit_vector(31 downto 0);
         init : IN  bit;
         ld : IN  bit;
         h : OUT  bit_vector(31 downto 0);
         v : OUT  bit;
         clk : IN  bit;
         rst : IN  bit
        );
    END COMPONENT;
	 
	 COMPONENT VADERtest
	 PORT( Clock	:	IN	bit; 
          TestHash	:	IN	bit_VECTOR (31 DOWNTO 0); 
          HashCorrectFlag	:	OUT	bit; 
          Reset	:	IN	bit; 
          Load	:	IN	bit;
			 valid : OUT bit;
			 hash : OUT bit_VECTOR (31 DOWNTO 0);
          Message	:	IN	bit_VECTOR (31 DOWNTO 0));
   END COMPONENT;
    
	 COMPONENT comparator
    PORT(
         original_hash : IN  bit_vector(31 downto 0);
         generated_hash : IN  bit_vector(31 downto 0);
         clk : IN  bit;
         valid : IN  bit;
         flag : OUT  bit
--         hash_out : OUT  bit_vector(31 downto 0)
        );
    END COMPONENT;

   --Inputs
   signal m : bit_vector(31 downto 0) := (others => '0');
   signal init : bit := '0';
   signal ld : bit := '0';
   signal clk : bit := '0';
   signal rst : bit := '0';
	signal original_hash : bit_vector(31 downto 0) := (others => '0');
   signal generated_hash : bit_vector(31 downto 0) := (others => '0');
   signal valid : bit := '0';

 	--Outputs
   signal flag : bit;
   signal hash_out : bit_vector(31 downto 0);

 	--Outputs
   signal h : bit_vector(31 downto 0);
   signal v : bit;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
	UUT: VADERtest PORT MAP(
		Clock => clk, 
		TestHash => original_hash, 
		HashCorrectFlag => flag, 
		Reset => rst,
		hash => h,
		valid => valid,
		Load => ld,		
		Message => m
   );
	
   s1: sha1 PORT MAP (
          m => m,
          init => init,
          ld => ld,
          h => h,
          v => v,
          clk => clk,
          rst => rst
        );
		  
	c1: comparator PORT MAP (
          original_hash => original_hash,
          generated_hash => generated_hash,
          clk => clk,
          valid => valid,
          flag => flag,
          hash_out => hash_out
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
