--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.4
--  \   \         Application : sch2hdl
--  /   /         Filename : VADERtest.vhf
-- /___/   /\     Timestamp : 05/17/2012 01:25:04
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3 -flat -suppress -vhdl C:/YODA/VADER/VADERtest.vhf -w C:/YODA/VADER/VADERtest.sch
--Design Name: VADERtest
--Device: spartan3
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity VADERtest is
   port ( Clock           : in    bit; 
          Load            : in    bit; 
          Message         : in    bit_vector (31 downto 0); 
          Reset           : in    bit; 
          TestHash        : in    bit_vector (31 downto 0); 
          bit_prb         : out   integer range 7 downto 0; 
          correct_prb     : out   integer range 7 downto 0; 
          hash            : out   bit_vector (31 downto 0); 
          HashCorrectFlag : out   bit; 
          valid           : out   bit);
end VADERtest;

architecture BEHAVIORAL of VADERtest is
   signal valid_DUMMY     : bit;
   signal hash_DUMMY      : bit_vector (31 downto 0);
   component sha1
      port ( init : in    bit; 
             ld   : in    bit; 
             clk  : in    bit; 
             rst  : in    bit; 
             m    : in    bit_vector (31 downto 0); 
             v    : out   bit; 
             h    : out   bit_vector (31 downto 0));
   end component;
   
   component comparator
      port ( clk            : in    bit; 
             valid          : in    bit; 
             original_hash  : in    bit_vector (31 downto 0); 
             generated_hash : in    bit_vector (31 downto 0); 
             flag           : out   bit; 
             bit_prb        : out   integer range 7 downto 0; 
             correct_prb    : out   integer range 7 downto 0);
   end component;
   
begin
   hash(31 downto 0) <= hash_DUMMY(31 downto 0);
   valid <= valid_DUMMY;
   XLXI_1 : sha1
      port map (clk=>Clock,
                init=>Load,
                ld=>Load,
                m(31 downto 0)=>Message(31 downto 0),
                rst=>Reset,
                h(31 downto 0)=>hash_DUMMY(31 downto 0),
                v=>valid_DUMMY);
   
   XLXI_9 : comparator
      port map (clk=>Clock,
                generated_hash(31 downto 0)=>hash_DUMMY(31 downto 0),
                original_hash(31 downto 0)=>TestHash(31 downto 0),
                valid=>valid_DUMMY,
                bit_prb=>bit_prb,
                correct_prb=>correct_prb,
                flag=>HashCorrectFlag);
   
end BEHAVIORAL;


