----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:09:11 05/16/2012 
-- Design Name: 
-- Module Name:    comparator - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all; -- std_logic stuff
use ieee.numeric_std.all;    -- basic math for std_logic

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity comparator is
port(
	original_hash            : in  bit_vector ( 31 downto 0);
	generated_hash           : in  bit_vector ( 31 downto 0);
	clk                      : in  bit;
	valid                    : in  bit;
	bit_prb : out integer range 7 downto 0;
	correct_prb : out integer range 7 downto 0;
	--test_prb : out bit;
	flag			             : out bit
--	hash_out				       : out bit_vector ( 31 downto 0)
	);
end comparator;

architecture Behavioral of comparator is
signal testing : bit := '0';
signal bitnumber : integer range 7 downto 0 := 0;
signal correctnumber : integer range 7 downto 0 := 0;
begin

process (clk,valid)
begin
if (clk = '1' and clk'event) then
	if (valid = '1') then
		testing <= '1';
	end if;
	if (bitnumber = 5) then
		testing <= '0';
	end if;
end if;
end process;

process (clk)
begin
if (clk = '1' and clk'event) then
	if (testing = '1') then 
		bitnumber <= bitnumber + 1;
		if ((original_hash = generated_hash)) then
			correctnumber <= correctnumber + 1;
		end if;
		if (bitnumber = 5) then
			if (correctnumber = 5) then
				flag <= '1';
			end if;
			correctnumber <= 0;
			bitnumber <= 0;
		end if;
	else
		flag <= '0';
	end if;
end if;
end process;
--hash_out <= generated_hash;
bit_prb <= bitnumber;
correct_prb <= correctnumber;

end Behavioral;

