//
//  main.cpp
//  goldenstandard
//
//  Created by Daniel Donaldson on 2012/05/08.
//  Copyright (c) 2012 dandon08@gmail.com. All rights reserved.
//

#include <iostream>
#include "hashlibpp.h"
#include <time.h>
#include <sys/time.h>

#define N_RUNS 1
#define N_SIZE 6

using namespace std;

int main2 (int argc, const char * argv[])
{
    struct timeval start_time, end_time;
    double run_time;
    string hashToFind;
    string initialPass = "!!!a23";
    string hash;
    bool found = false;

//    hashwrapper *h = new sha512wrapper();
//    hashwrapper *h = new sha256wrapper();
    hashwrapper *h = new sha1wrapper();
//    hashwrapper *h = new md5wrapper();
    h->test();
    
    char* test = new char[N_SIZE];
    for (int i = 0; i< N_SIZE;i++)
        test[i] = '!';
   
    hashToFind = h->getHashFromString(initialPass);
    cout << "Searching for password: " << initialPass << " with hash of: " << hashToFind<< endl;
    
    gettimeofday(&start_time, NULL);
    while (!found)
    {
        
        hash = h->getHashFromString(test);
        //cout << "testing: " << test << " with " << md5 << " against " << hashToFind << endl;
        if (hash == hashToFind)
        {
            found = true;
            break;
        }
        else
        {
//            if (test[7] == '~') 
//            {
//                if (test[6] == '~')
//                {
                    if (test[5] == '~')
                    {
                        if (test[4] == '~')
                        {
                            if (test[3] == '~')
                            {
                                if (test[2] == '~')
                                {
                                    if (test[1] == '~')
                                    {
                                        if (test[0] == '~')
                                        {
                                            break;
                                        }
                                        else
                                        {
                                            test[0]++;
                                            test[1] = '!';
                                            test[2] = '!';
                                            test[3] = '!';
                                            test[4] = '!';
                                            test[5] = '!';
//                                            test[6] = '!';
//                                            test[7] = '!';
                                        }
                                    }
                                    else
                                    {
                                        test[1]++;
                                        test[2] = '!';
                                        test[3] = '!';
                                        test[4] = '!';
                                        test[5] = '!';
//                                        test[6] = '!';
//                                        test[7] = '!';
                                    }
                                }
                                else
                                {
                                    test[2]++;
                                    test[3] = '!';
                                    test[4] = '!';
                                    test[5] = '!';
//                                    test[6] = '!';
//                                    test[7] = '!';
                                }
                            }
                            else
                            {
                                test[3]++;
                                test[4] = '!';
                                test[5] = '!';
//                                test[6] = '!';
//                                test[7] = '!';
                            }
                        }
                        else
                        {
                            test[4]++;
                            test[5] = '!';
//                            test[6] = '!';
//                            test[7] = '!';
                        }
                    }
                    else
                    {
                        test[5]++;
//                        test[6] = '!';
//                        test[7] = '!';
                    }
//                }
//                test[6]++;
//                test[7] = '!';
//            }
//            else
//                test[7]++;
        }
    }
    gettimeofday(&end_time, NULL);
    cout << "Found password as: " << test << " with hash of " << hash << endl;
    run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
    - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
    std::cout << "Time taken to find password: " << run_time << std::endl;
    
}

int main (int argc, const char * argv[])
{
    struct timeval start_time, end_time;
    double run_time;
    
//    hashwrapper *h = new md5wrapper();
//    h->test();
//    std::string md5;
//    gettimeofday(&start_time, NULL);
//    for (int i = 0; i < N_RUNS; i++)
//        md5 = h->getHashFromString("hello world");
//    gettimeofday(&end_time, NULL);
//	std::cout << "md5: " << md5 << std::endl;
//    run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
//    - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
//    std::cout << "time taken for md5: " << run_time << std::endl;
    
    hashwrapper *s1 = new sha1wrapper();
    s1->test();
    std::string sha1;
    gettimeofday(&start_time, NULL);
    for (int i =0; i < N_RUNS;i++)
        sha1 = s1->getHashFromString("abcde");
    gettimeofday(&end_time, NULL);
    std::cout << "sha1: " << sha1 << std::endl;
    run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
    - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
    std::cout << "time taken for sha1: " << run_time << std::endl;
    
//    hashwrapper *s2 = new sha256wrapper();
//    s2->test();
//    std::string sha2;
//    gettimeofday(&start_time, NULL);
//    for (int i = 0; i< N_RUNS;i++)
//        sha2 = s2->getHashFromString("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
//    gettimeofday(&end_time, NULL);
//    std::cout << "sha256: " << sha2 << std::endl;
//    run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
//    - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
//    std::cout << "time taken for sha256: " << run_time << std::endl;
//    
//    hashwrapper *s3 = new sha512wrapper();
//    s3->test();
//    std::string sha3;
//    gettimeofday(&start_time, NULL);
//    for (int i = 0; i < N_RUNS; i++)
//        sha3 = s3->getHashFromString("hello world");
//    gettimeofday(&end_time, NULL);
//    std::cout << "sha512: " << sha3 << std::endl;
//    run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
//    - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
//    std::cout << "time taken for sha512: " << run_time << std::endl;
    
    
    // insert code here...
    //std::cout << "Hello, Worlds!\n";
//    delete h;
//    delete s1;
//    delete s2;
//    delete s3;
    return 0;
}
